#include <QTRSensors.h>

QTRSensors qtr;

const uint8_t SensorCount = 8;
uint16_t sensorValues[SensorCount];

float KP = 0.2; 
float KI = 0.01;
float KD = 0.5;

int error,P,I,D,motorspeed;
int lastError = 0;
boolean onoff = false;

int sl=150;
int sp=150;
int a,b;

void setup()
{
 
  pinMode(0,OUTPUT);
  pinMode(1,OUTPUT); 
  pinMode(3,OUTPUT);
  pinMode(4,OUTPUT);
  pinMode(5,OUTPUT);
  pinMode(6,OUTPUT);
  pinMode(7,OUTPUT);
  pinMode(8,OUTPUT);
  pinMode(9,OUTPUT);

 
  qtr.setTypeRC();
  qtr.setSensorPins((const uint8_t[]){A3, A2, A1, A0, 15, 14, 16, 10}, SensorCount);
  qtr.setEmitterPin(1);
   delay(500);
  for (int z=0; z<5; z++){
  digitalWrite(0,LOW);
  delay(200);
  digitalWrite(0,HIGH);
  delay(200);
  }
    boolean Ok = false;
     while (Ok == false) { 
     if(digitalRead(4) == HIGH) {
      calibration(); 
      Ok = true;
    }
  }

 
}

void calibration() {
  digitalWrite(0, LOW);
  for (uint16_t i = 0; i < 400; i++)
  {
    qtr.calibrate();
  }
  digitalWrite(0, HIGH);
}


void loop() {
  
if (digitalRead(4)==1){
   onoff =! onoff;
    if(onoff = true) {
      delay(1000);
    }
    else {
      delay(50);
    }
  }
  if (onoff == true) {
    PID();
  }
  else {
    mowe(0,0);
  }


}
void PID(){
uint16_t position = qtr.readLineBlack(sensorValues);
error=3500-position;
P=error;
I=I+error;
D=error-lastError;
lastError=error;
motorspeed=P*KP+I*KI+D*KD;
a=sl+motorspeed;
b=sp-motorspeed;
if (a>255) a=255;
if (a<0) a=0;
if (b>255) b=255;
if (b<0) b=0;  
mowe(a,b);
}

void mowe (int posa, int posb){
 
analogWrite(3,posb);
analogWrite(5,posa);
digitalWrite(6,1);
digitalWrite(7,0);
digitalWrite(8,1);
digitalWrite(9,0);
}
